;;; inspired by jrose@sun.com (John Rose)
;;; Make sure Common Lisp c[ad]+r functions are defined,
;;; and not as macros!
;;; LastEditDate="Mon Oct  3 13:09:13 1988" by merlyn

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; From info-gnu-emacs-request@prep.ai.mit.edu  Tue Oct  4 08:45:59 1988
;;; Received: from TUT.CIS.OHIO-STATE.EDU by prep.ai.mit.edu; Tue, 4 Oct 88 07:34:08 EST
;;; Received: by tut.cis.ohio-state.edu (5.54/2.880920)
;;; 	id AA28920; Tue, 4 Oct 88 04:32:40 EDT
;;; Received: from USENET by tut.cis.ohio-state.edu with netnews
;;; 	for info-gnu-emacs@prep.ai.mit.edu (info-gnu-emacs@prep.ai.mit.edu)
;;; 	(contact usenet@tut.cis.ohio-state.edu if you have questions)
;;; Date: 3 Oct 88 22:23:30 GMT
;;; From: oliveb!intelca!mipos3!merlyn@sun.com  (Randal L. Schwartz @ Stonehenge)
;;; Organization: Stonehenge; netaccess via BiiN, Hillsboro, Oregon, USA
;;; Subject: a new version of define-cxxr-function
;;; Message-Id: <2966@mipos3.intel.com>
;;; Sender: info-gnu-emacs-request@prep.ai.mit.edu
;;; To: info-gnu-emacs@prep.ai.mit.edu
;;; 
;;; Here's something for you hackers that want cXXr functions that run
;;; fast.  Enjoy.
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(provide 'cl-cadr)
(require 'byte-compile "bytecomp")

(defun define-cxxr-function (xx)
  "Given string XX, create standard function cXXr."
  (and (not (string-match "^[ad][ad]+$" xx))
       (error "define-cxxr-function: invalid argument"))
  (let ((f (intern (format "c%sr" xx)))
	(form 'x))
    (while (> (length xx) 0)
      (setq form (list (intern (format "c%sr" (substring xx -1))) form)
	    xx (substring xx 0 -1)))
    (fset f (byte-compile-lambda (list 'lambda '(x)
				       "Created by define-cxxr-function."
				       form)))))

(mapcar 'define-cxxr-function
	'("aa" "ad" "da" "dd"
	  "aaa" "aad" "ada" "add" "daa" "dad" "dda" "ddd"
	  "aaaa" "aaad" "aada" "aadd" "adaa" "adad" "adda" "addd"
	  "daaa" "daad" "dada" "dadd" "ddaa" "ddad" "ddda" "dddd"))
