(load "xscheme")

(setq xscheme-process-filter-alist
  (cons '(?L gambit-show-location
             xscheme-process-filter:string-action)
        xscheme-process-filter-alist))

(defun gambit-show-location (string)
  (if (string-match "^[0-9]+ " string)
    (let ((end (match-end 0)))
      (let ((line (string-to-int (substring string 0 end)))
            (rest (substring string end)))
        (if (string-match "^[0-9]+ " rest)
          (let ((end (match-end 0)))
            (let ((char (string-to-int (substring rest 0 end))))
              (gambit-show-loc line char (substring rest end))))
          (gambit-show-loc line 1 rest))))
    (gambit-show-loc 1 1 string)))

(defun gambit-show-loc (line char filename)
  (setq filename (expand-file-name filename))
  (cond ((file-directory-p filename)
         (error "%s is a directory." filename))
        ((not (file-exists-p filename))
         (error "Can't find file %s" filename))
        (t
         (find-file-other-window filename)
         (goto-line line)
         (forward-char (- char 1)))))
