(provide 'gnus-other-indent)

(setq gnus-show-threads nil)

(setq gnus-Select-group-hook
      '(lambda ()
	 (mapcar (function
		  (lambda (header)
		    (nntp-set-header-subject
		     header
		     (gnus-simplify-subject
		      (gnus-header-subject header) 're-only))))
		 gnus-newsgroup-headers)
	 (ange-sort-headers)))

(defun ange-sort-headers ()
  (let (alist)				;assoc list keyed on subject
    (mapcar				;sort headers into subject buckets
     (function (lambda (header)
		 (let ((entry (assoc (nntp-header-subject header) alist)))
		   (if entry
		       (rplacd entry (cons header (cdr entry)))
		     (setq alist 
			   (cons (list (nntp-header-subject header) header) alist))))))
     gnus-newsgroup-headers)
    (setq gnus-newsgroup-headers nil)
    (mapcar				;extract headers from buckets
     (function (lambda (bucket)
		 (setq gnus-newsgroup-headers
		       (nconc (cdr bucket) gnus-newsgroup-headers))))
     (nreverse alist))
    (setq gnus-newsgroup-headers (nreverse gnus-newsgroup-headers))))
