; -*-Emacs-Lisp-*-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; File:         lint.el
; RCS:          $Header: $
; Description:  Functions to parse lint output
; Author:       Darryl Okahata
; Created:      Sun Oct 29 22:41:12 1989
; Modified:     Sat Feb 23 17:13:15 1991 (Darryl Okahata)
; Language:     Emacs-Lisp
; Package:      N/A
;
; (C) Copyright 1989, 1990, 1991, Hewlett-Packard, all rights reserved.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


(defun lint-find-file ()
  "Return the name of the file responsible for the output at point."
  (interactive "")
  (let ( (current (point)) start stop)
    (re-search-backward "^==============$")
    (previous-line 1)
    (beginning-of-line 1)
    (setq start (point))
    (end-of-line 1)
    (setq stop (point))
    (goto-char current)
    (buffer-substring start stop)
  )
)

(defun lint-find-line ()
  "Return the line number in the file responsible for the output at point."
  (interactive "")
  (let ( (current (point)) start stop )
    (forward-char 1)
    (re-search-backward "(")
    (forward-char 1)
    (setq start (point))
    (re-search-forward ")")
    (backward-char 1)
    (setq stop (point))
    (goto-char current)
    (buffer-substring start stop)
  )
)


(defun lint-goto-problem ()
  "Show the file and line responsible for the lint output under the cursor."
  (interactive "")
  (let ( (file (lint-find-file)) (line (string-to-int (lint-find-line))) )
    (find-file file)
    (goto-line line)
  )
)
