; -*-Emacs-Lisp-*-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; File:         rmb.el
; RCS:          $Header: rmb.el,v 2.1 89/04/24 18:38:25 darrylo Exp $
; Description:  Small amount of code to help edit rocky mountain basic
; Author:       Rick Kunin, SPE
; Created:      Fri Apr  7 11:32:16 1989
; Modified:     Wed Feb 27 21:26:41 1991 (Darryl Okahata)
; Language:     Emacs-Lisp
; Package:      N/A
;
; (c) Copyright 1989, 1990, 1991, Hewlett-Packard Company, all rights reserved.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun strip-line-numbers ()
  "Strip Basic line numbers from file"
  (interactive)
  (save-excursion
    (goto-char (point-min))
    (replace-regexp "^[0-9]*" "")
    ))



(defun rmb-insert-line-numbers ()
  "Add line numbers to an rocky mountain basic file"
  (interactive)
  (let (nlines
	(line-number 1))
    (save-restriction
      (widen)
      (save-excursion
	(goto-char (point-min))
	(while (not (= (point) (point-max)))
	  (insert-before-markers (int-to-string line-number) " ")
	  (forward-line 1)
	  (setq line-number (1+ line-number)))))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; I found this in /usr/local/emacs/lisp/local/rmb.el and modified it
;;; slightly.  Thought you might be interested in it for adding or stripping
;;; RMB line numbers.  I've set it up to start line numbers at 10000 and
;;; increment by 1.  This way, any indentation you have set up without the
;;; line numbers won't get messed up when you add the line numbers (As it
;;; does when line numbers change from 9 to 10, 99 to 100, 999 to 1000, and
;;; 9999 to 10000).  Of course, you're limited to 26,766 lines of RMB code
;;; though.
;;;

(defun stripLN ()
  "Strip RMB (Rocky Mountain Basic) line numbers from file."
  (interactive)
  (save-excursion
    (goto-char (point-min))
    (replace-regexp "^[0-9]*" "")
    ))


(defun addLN ()
  "Add line numbers (starting at 10000) to an RMB (Rocky Mountain Basic) file."
  (interactive)
  (let (nlines
	(line-number 10000))
    (save-restriction
      (widen)
      (save-excursion
	(goto-char (point-min))
	(while (not (= (point) (point-max)))
	  (insert-before-markers (int-to-string line-number)    )
	  (forward-line 1)
	  (setq line-number (1+ line-number)))))))
