; -*-Emacs-Lisp-*-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; File:         site-init.el
; RCS:          $Header: $
; Description:  site-init file for arkin
; Author:       Christian Limpach <chris@nice.ch>
; Created:      Tue May 24 01:13:11 1994
; Modified:     Sat Aug 20 20:26:49 1994 (Christian Limpach) chris@nice.ch
; Language:     Emacs-Lisp
; Package:      N/A
; Status:       Experimental (Do Not Distribute)
;
; (C) Copyright 1994, Christian Limpach, all rights reserved.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; original by Carl Edman <cedman@princeton.edu>

;;(load-library "crypt++")
(load-library "dired")
(load-library "dired-x19")
(load-library "ange-ftp")
(load-library "load-lib-comp")
(load-library "ispell")
(load-library "ispell-message")
(load-library "xscheme")
;;(load-library "saveplace")
(load-library "icomplete")
;; temporary fix, as long as c-mode is loaded in loadup.el
(fmakunbound 'c-mode)
(makunbound 'c-mode-map)
(fmakunbound 'c++-mode)
(makunbound 'c++-mode-map)
(makunbound 'c-style-alist)
;; end temp fix
(load-library "cc-mode")
(load-library "header3")
(load-library "sh-script")
(load-library "nroff-mode")
;;(load-library "iso-acc")
(load-library "iso-syntax")

(autoload 'swap-bs-del "swap-bsdel"
  "swaps backspace and delete key in translation table" t)
(autoload 'hide-copyleft-region "hide-copyleft" nil t)
(autoload 'unhide-copyleft-region "hide-copyleft" nil t)
(autoload 'smalltalk-mode "st" "Nifty mode for smalltalk" t)
(autoload 'bison-mode "bison" "Mode for editing yacc and bison files" t)
(autoload 'perl-mode "perl-mode" "use mode for perl" t)
(autoload 'find-this-error "this-error"
  "jump to error on current line of error buffer" t)
(autoload 'format-lisp-code-directory "lispdir" nil t)
(autoload 'lisp-dir-apropos "lispdir"
  "Find out about availability of emacs lisp packages." t)
(autoload 'lisp-dir-retrieve "lispdir" nil t)
(autoload 'lisp-dir-verify "lispdir" nil t)
(autoload 'vm "vm" "View mail" t)

(autoload 'w3-preview-this-buffer "w3" "WWW Previewer" t)
(autoload 'w3-follow-url-at-point "w3" "Find document at pt" t)
(autoload 'w3 "w3" "WWW Browser" t)
(autoload 'w3-open-local "w3" "Open local file for WWW browsing" t)
(autoload 'w3-fetch "w3" "Open remote file for WWW browsing" t)
(autoload 'w3-use-hotlist "w3" "Use shortcuts to view WWW docs" t)
(autoload 'w3-show-hotlist "w3" "Use shortcuts to view WWW docs" t)
(autoload 'w3-follow-link "w3" "Follow a hypertext link." t)
(autoload 'w3-batch-fetch "w3" "Batch retrieval of URLs" t)
(autoload 'url-get-url-at-point "url" "Find the url under the cursor" nil)
(autoload 'url-file-attributes  "url" "File attributes of a URL" nil)
(autoload 'url-popup-info "url" "Get info on a URL" t)
(autoload 'url-retrieve   "url" "Retrieve a URL" nil)
(autoload 'url-buffer-visiting "url" "Find buffer visiting a URL." nil)
(autoload 'gopher-dispatch-object "gopher" "Fetch gopher dir" t)

(autoload 'html-mode "html-mode" "Edit HTML docs" t)
(autoload 'describe-perl-symbol "perl-descr"
  "One-line information on a perl symbol" t)
(autoload 'switch-to-perl-doc-buffer "perl-descr"
  "One-line information on a perl symbol" t)
(autoload 'bbdb         "bbdb-com" "Insidious Big Brother Database" t)
(autoload 'bbdb-name    "bbdb-com" "Insidious Big Brother Database" t)
(autoload 'bbdb-company "bbdb-com" "Insidious Big Brother Database" t)
(autoload 'bbdb-net     "bbdb-com" "Insidious Big Brother Database" t)
(autoload 'bbdb-notes   "bbdb-com" "Insidious Big Brother Database" t)
(autoload 'bbdb-insinuate-vm       "bbdb-vm"    "Hook BBDB into VM")
(autoload 'bbdb-insinuate-rmail    "bbdb-rmail" "Hook BBDB into RMAIL")
(autoload 'bbdb-insinuate-mh       "bbdb-mhe"   "Hook BBDB into MH-E")
(autoload 'bbdb-insinuate-rmail    "bbdb-rmail" "Hook BBDB into RMAIL")
(autoload 'bbdb-insinuate-mh       "bbdb-mhe"   "Hook BBDB into MH-E")
(autoload 'bbdb-insinuate-gnus     "bbdb-gnus"  "Hook BBDB into GNUS")
(autoload 'bbdb-insinuate-sendmail "bbdb"       "Hook BBDB into sendmail")

(autoload 'c++-mode  "cc-mode" "C++ Editing Mode" t)
(autoload 'c-mode    "cc-mode" "C Editing Mode" t)
(autoload 'objc-mode "cc-mode" "Objective-C Editing Mode" t)

(autoload 'awk-mode  "awk-mode" "AWK Editing Mode" t)

(eval-after-load "perl-mode"
		 '(define-key perl-mode-map "\M-l" 'describe-perl-symbol))
(eval-after-load "makefile"
		 '(define-key makefile-mode-map "\C-i" 'self-insert-command))

;; not needed with header3
;;(setq buffer-header-defaults
;;      (append '((c++-mode          . (?\* "/* -*-C++-*-" "*/"))
;;		(objc-mode         . (?\* "/* -*-ObjC-*-" "*/"))
;;		(perl-mode         . (?\# "# -*-Perl-*-" nil))
;;		) buffer-header-defaults))

(setq auto-mode-alist
      (append '(("\\.awk$"     . awk-mode)
		("\\.C$"       . c++-mode)
		("\\.cc$"      . c++-mode)
		("\\.c$"       . c-mode)   ; to edit C code
		("\\.h$"       . c-mode)   ; to edit C code
		("\\.m$"       . objc-mode)
		("\\.ma$"      . math-mode)
		("\\.pl$"      . perl-mode)
		("\\.st$"      . smalltalk-mode)
		("\\.y$"       . bison-mode)
		("\\.[1-9ln]$" . nroff-mode)
		("[Mm]akefile" . makefile-mode)
		("\\.mk$"      . makefile-mode)
		) auto-mode-alist))
