; -*-Emacs-Lisp-*-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; File:         sk.el
; RCS:          $Header: $
; Description:  Softkey enhancements
; Author:       Eric Ross
; Created:      28 Apr 1989
; Modified:     Sat Feb 23 20:35:55 1991 (Darryl Okahata)
; Language:     Emacs-Lisp
; Package:      N/A
;
; (C) Copyright 1989, 1990, 1991, Hewlett-Packard, all rights reserved.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Subject: Softkey enhancement.
;; Date: Fri, 28 Apr 89 7:06:12 PDT
;; 
;; Here is a tidbit you may want to include in the HP-emacs.  Use occasional
;; users of softkeys find it extremely useful.  It makes the MENU key a
;; toggle for displaying the softkeys.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; The softkeys are loaded, but turn them off until we want them.
(softkeys-off)
(defvar sfk-off t)
(defun softkeys-toggle ()
  "Toggle the softkeys label display"
  (interactive)
  (if (eq sfk-off 't)
      (progn
	(softkeys-on)
	(setq sfk-off nil))
    (progn
      (softkeys-off)
      (setq sfk-off t))))

(defvar esc-bracket-map (make-sparse-keymap) "*Keymap for ESC-[ sequences")
(define-key esc-bracket-map "29~" 'softkeys-toggle)             ; Menu
(define-key esc-map "[" esc-bracket-map)
