;;;;;;;;;;;;;;;;;;;;;;;;;;; -*- Mode: Emacs-Lisp -*- ;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 
;; tex-site.el - Site local variables for the auc-tex package
;; 
;; Copyright (C) 1991 Kresten Krab Thorup (krab@iesd.auc.dk).
;; 
;; 
;; 
;; $Id: tex-site.el,v 5.0 1991/12/07 23:43:03 krab Exp krab $
;; 
;; LCD Archive Entry:
;; tex-site.el|Kresten Krab Thorup|krab@iesd.auc.dk
;; | Site local variables for the auc-tex package
;; |$Date: 1991/12/07 23:43:03 $|$Revision: 5.0 $|iesd.auc.dk:/pub/emacs-lisp
;; 
;; Author          : Kresten Krab Thorup
;; Created On      : Sun Sep  1 17:39:50 1991
;; Last Modified By: Kresten Krab Thorup
;; Last Modified On: Sat Dec  7 22:20:48 1991
;; Update Count    : 42
;; 
;; HISTORY
;; 
(provide 'tex-site)

(defvar TeX-printer-name-alist '(("Local_Printer"))
  "*List of available printeroptions using the \"-P\" option to TeX-print-command")

(defvar TeX-default-jobname-prefix "+"
  "*Prefix to set on temporary files when running TeX-region.")

(defvar TeX-command nil
  "*The command to run TeX on a file.  The name of the file will be appended
to this string, separated by a space.")

(defvar TeX-print-command "dvips"
  "*The command to print the .dvi file.")

(defvar TeX-bibtex-command "bibtex"
  "*The command to run BibTeX")

(defvar TeX-index-command "makeindex"
  "*The command to run a program generating an index, usually \"makeindex\"")

(defvar TeX-index-suffix ".ind"
  "*The suffix (file-name-extention) of the file generated by \\[LaTeX-makeindex]")

(defvar TeX-default-printer-name "Local_Printer"
  "*Name of the printer used by the print-command. Appended to the `-P' option")

(defvar TeX-compilation-cd-command "cd"
  "*Command to give to shell running TeX to change directory.  The expanded
value of TeX-directory will be appended to this, separated by a space.")

(defvar TeX-default-mode 'latex-mode
  "*Mode to enter for a new file when it can't be determined whether
the file is plain TeX or LaTeX or what.")

(defvar LaTeX-default-environment "itemize"
  "*The default environment when creating new ones with
LaTeX-environment.")

(defvar LaTeX-default-style "article"
  "*Default when creating new documents.")

(defvar LaTeX-default-style-options ""
  "*Default options to documentstyle")

(defvar LaTeX-float "tbp"
  "*Default float when creating figure and table environments.")

(defvar LaTeX-figure-label "fig:"
  "*Default prefix to figure labels.")

(defvar LaTeX-table-label "tab:"
  "*Default prefix to table labels.")

(defvar LaTeX-section-label "sec:"
  "*Default prefix when asking for a label.")

;; one of `LATEX', `OLATEX' `TEX' or `SLITEX'... `LATEX' uses the new
;; font selection scheme, while `OLATEX' uses the old.

(defvar LaTeX-format-package '( "LATEX" ))

(defvar TeX-format-package '( "TEX" ))

;;
;;

(defvar TeX-preview-command  (cond

                              ;; if we run under NeXTStep
                              ((getenv "Workspace")
                               "open -a /NextApps/TeXview")

			      ;; if we're in OpenWindows
			      ((getenv "NEWSSERVER")	
			       "dvips -Pageview")

			      ;; else if in the M.I.T. X window system
			      ((getenv "DISPLAY")
			       "xdvi")

			      ;; else we assume some terminal
			      (t "dvitty -q -w 80"))

  "*The command used for previewing.
The filename of the dvi-file will be appended separated by a space")

(defvar TeX-complete-word (key-binding "\e\t")
  "*Function to call if M-t is invoked on a word which does not start 
with a backslash. Default is the meaning of M-t when latex-mode was
first invoked.")

(defvar LaTeX-indent-level 2
  "*Indentation of begin-end blocks in LaTeX.")

(defvar LaTeX-item-indent -2
  "*Extra indentation for lines beginning with \\item{.")

(defvar TeX-auto-header "texheader"
  "*filename for TeX-headers. \input by TeX, so the real file should have
the extention `.tex'")

(defvar TeX-auto-trailer "textrailer"
  "*filename for TeX-trailers \input by TeX, so the real file should have
the extention `.tex'")

